Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.nwoods.jgo
Class JGoDrawable

    java.lang.Object
      com.nwoods.jgo.JGoObject
          com.nwoods.jgo.JGoDrawable

All Implemented Interfaces:
  JGoXMLSaveRestore, java.io.Serializable

Direct Known Subclasses:
  AbstractGraduatedScale, AbstractIndicator, JGoEllipse, JGoPort, JGoRectangle, JGoRoundRect, JGoStroke

public abstract class JGoDrawable
extends JGoObject

The parent of any class that is drawn by lines and fills. This class takes care of managing Pens and Brushes for a drawable object.

Pens define the line style used -- their color, their width, and their pattern. Brushes define the fill style used -- their color and pattern.

Users of a JGoDrawable class use these functions to change fill color and line style, etc.

See Also:
  `JGoPen`, `JGoBrush`, Serialized Form

Field Summary

Fields inherited from class com.nwoods.jgo.JGoObject
`Bottom, BottomCenter, BottomLeft, BottomMiddle, BottomRight, Center, CenterLeft, CenterRight, Changed4ResizeHandles, ChangedAutoRescale, ChangedBrush, ChangedDraggable, ChangedDragsNode, ChangedGeometry, ChangedGrabChildSelection, ChangedInitializing, ChangedPen, ChangedResizable, ChangedSelectable, ChangedUpdatePartner, ChangedVisible, ChangedZOrder, LastChangedHint, Left, LeftCenter, NoHandle, NoSpot, NumReservedHandles, RepaintAll, Right, RightCenter, SideLeft, SideRight, Top, TopCenter, TopLeft, TopMiddle, TopRight`

Constructor Summary
`JGoDrawable()` Create a new drawable object with no dimensions.
`JGoDrawable(java.awt.Point location, java.awt.Dimension size)` Create a new drawable object with the given location and size.
`JGoDrawable(java.awt.Rectangle rect)` Create a new drawable object with the given bounding rectangle.

Method Summary
`void` | `changeValue(JGoDocumentChangedEdit e, boolean undo)` This method is called by the JGoDocumentChangedEdit.undo and redo methods to actually perform the property value change for a JGoObject.
`void` | `copyNewValueForRedo(JGoDocumentChangedEdit e)` This method is called when a JGoDocumentChangedEdit is created for a JGoDocumentEvent.CHANGED event, when a JGoObject has been changed.
`JGoObject` | `copyObject(JGoCopyEnvironment env)` Create a new instance of this object with the same field values.
`void` | `draw3DRect(java.awt.Graphics2D g, int x, int y, int width, int height, boolean raised)` Draw a 3D rectangle using the current pen and brush.
`static void` | `draw3DRect(java.awt.Graphics2D g, JGoPen pen, JGoBrush brush, int x, int y, int width, int height, boolean raised)` Draw a rectangle with a 3D appearance, using a specified pen and brush.
`void` | `drawEllipse(java.awt.Graphics2D g, int x, int y, int width, int height)` Draw an ellipse, using the current pen and brush.
`static void` | `drawEllipse(java.awt.Graphics2D g, JGoPen pen, JGoBrush brush, int x, int y, int width, int height)` Draw an ellipse, using a specified pen and brush.
`void` | `drawEllipse(java.awt.Graphics2D g, java.awt.Rectangle rect)` Draw an ellipse, using the current pen and brush, given a rectangle.
`void` | `drawLine(java.awt.Graphics2D g, int x1, int y1, int x2, int y2)` Draw a straight line, using the current pen (and no brush).
`static void` | `drawLine(java.awt.Graphics2D g, JGoPen pen, int x1, int y1, int x2, int y2)` Draw a straight line, using a specified pen.
`static void` | `drawPath(java.awt.Graphics2D g, JGoPen pen, JGoBrush brush, java.awt.geom.GeneralPath path)` Draw a GeneralPath using a specified pen and brush.
`void` | `drawPolygon(java.awt.Graphics2D g, int[] xpoints, int[] ypoints, int npoints)` Draw a polygon using the current pen and brush.
`static void` | `drawPolygon(java.awt.Graphics2D g, JGoPen pen, JGoBrush brush, int[] xpoints, int[] ypoints, int npoints)` Draw a polygon using a specified pen and brush.
`void` | `drawRect(java.awt.Graphics2D g, int x, int y, int width, int height)` Draw a rectangle, using the current pen and brush.
`static void` | `drawRect(java.awt.Graphics2D g, JGoPen pen, JGoBrush brush, int x, int y, int width, int height)` Draw a rectangle, using a specified pen and brush.
`void` | `drawRect(java.awt.Graphics2D g, java.awt.Rectangle rect)` Draw a rectangle using the current pen and brush, given a Rectangle.
`void` | `drawRoundRect(java.awt.Graphics2D g, int x, int y, int width, int height, int arcWidth, int arcHeight)` Draw a rectangle with rounded corners, using the current pen and brush.
`static void` | `drawRoundRect(java.awt.Graphics2D g, JGoPen pen, JGoBrush brush, int x, int y, int width, int height, int arcWidth, int arcHeight)` Draw a rectangle with rounded corners, using a specified pen and brush.
`void` | `expandRectByPenWidth(java.awt.Rectangle rect)` Modify the given rectangle representing an object's bounding rectangle to account for any additional drawing region caused by the thickness of the pen.
`JGoBrush` | `getBrush()` Returns the current "paint brush" for this object.
`boolean` | `getNearestIntersectionPoint(int px, int py, int cx, int cy, java.awt.Point result)` Consider the pen width in determining the nearest intersection point.
`JGoPen` | `getPen()` Returns the current "pen stroke" for this object.
`void` | `setBrush(JGoBrush b)` Sets the current "paint brush" to use when filling this drawable object.
`void` | `setPen(JGoPen pen)` Sets the current "pen stroke" to use when drawing this drawable object.
`static void` | `SVGAddPathArgs(DomElement svgElement, java.awt.geom.GeneralPath path)` Add SVG attributes to the element specified by svgElement to draw the path specified by the "path" GeneralPath This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.
`void` | `SVGReadAttributes(DomElement svgElement)` This method will read attributes from standard SVG elements.
`DomNode` | `SVGReadObject(DomDoc svgDoc, JGoDocument jGoDoc, DomElement svgElement, DomElement jGoChildElement)` Read this object in from a DomDoc representing a Scalable Vector Graphics (SVG) XML document.
`void` | `SVGUpdateReference(java.lang.String attr, java.lang.Object referencedObject)` This method will be called to fill in object references.
`void` | `SVGWriteAttributes(DomElement svgElement)` This method will add attributes to standard SVG elements.
`void` | `SVGWriteObject(DomDoc svgDoc, DomElement jGoElementGroup)` Write this object out to a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

Methods inherited from class com.nwoods.jgo.JGoObject
`canView, computeBoundingRect, computeMove, computeResize, copy, copyObjectDelayed, copyOldValueForUndo, copyRect, doMouseClick, doMouseDblClick, doUncapturedMouseMove, findCommonParent, foredate, gainedSelection, geometryChange, geometryChangeChild, getBoundingRect, getDocument, getDraggingObject, getFlags, getHeight, getLayer, getLeft, getLocation, getLocation, getParent, getParentJGoNode, getParentNode, getPartner, getRectangleSpotLocation, getSize, getSize, getSpotLocation, getSpotLocation, getToolTipText, getTop, getTopLeft, getTopLeft, getTopLevelObject, getView, getWidth, growRect, handleMove, handleResize, hideSelectionHandles, is4ResizeHandles, isAutoRescale, isBoundingRectInvalid, isChildOf, isDraggable, isDragsNode, isInitializing, isPointInObj, isResizable, isSelectable, isSkipsUndoManager, isSuspendChildUpdates, isSuspendUpdates, isTopLevel, isUpdatePartner, isVisible, lostSelection, ownerChange, paint, partnerUpdate, pick, redirectSelection, remove, set4ResizeHandles, setAutoRescale, setBoundingRect, setBoundingRect, setBoundingRect, setBoundingRectForce, setBoundingRectForce, setBoundingRectInvalid, setBoundsRect, setDraggable, setDragsNode, setFlags, setHeight, setInitializing, setLeft, setLocation, setLocation, setLocationOffset, setLocationOffset, setParent, setPartner, setRectangleSpotLocation, setResizable, setSelectable, setSize, setSize, setSizeKeepingLocation, setSkipsUndoManager, setSpotLocation, setSpotLocation, setSpotLocation, setSpotLocationOffset, setSuspendChildUpdates, setSuspendUpdates, setTop, setTopLeft, setTopLeft, setUpdatePartner, setVisible, setWidth, showSelectionHandles, spotOpposite, update, update`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JGoDrawable

    public JGoDrawable()

  Create a new drawable object with no dimensions.

  Any subclass that you write should call one of these constructors.

### JGoDrawable

    public JGoDrawable(java.awt.Rectangle rect)

  Create a new drawable object with the given bounding rectangle.

  Any subclass that you write should call one of these constructors.

### JGoDrawable

    public JGoDrawable(java.awt.Point location,
                       java.awt.Dimension size)

  Create a new drawable object with the given location and size.

  Any subclass that you write should call one of these constructors.

Method Detail

### copyObject

    public JGoObject copyObject(JGoCopyEnvironment env)

  Create a new instance of this object with the same field values.

  Overrides:
    `copyObject` in class `JGoObject`
  Parameters:
    `env` - the environment for the copy operation - keeps track of copied objects.
  Returns:
    a newly allocated copy of this object, or null

### setPen

    public void setPen(JGoPen pen)

  Sets the current "pen stroke" to use when drawing this drawable object.

  The CHANGED event fired by this routine will have a ChangedPen value as the flag/subhint.

  Parameters:
    `pen` - the JGoPen to use when drawing the lines.

### getPen

    public JGoPen getPen()

  Returns the current "pen stroke" for this object.

  Returns:
    the current pen used to draw this object.

### setBrush

    public void setBrush(JGoBrush b)

  Sets the current "paint brush" to use when filling this drawable object.

  The CHANGED event fired by this routine will have a ChangedBrush value as the flag/subhint.

  Parameters:
    `b` - the brush to use when filling the object.

### getBrush

    public JGoBrush getBrush()

  Returns the current "paint brush" for this object.

  Returns:
    the current brush used to fill inside this object.

### copyNewValueForRedo

    public void copyNewValueForRedo(JGoDocumentChangedEdit e)

  Description copied from class: `JGoObject`
  This method is called when a JGoDocumentChangedEdit is created for a JGoDocumentEvent.CHANGED event, when a JGoObject has been changed. In order for the JGoDocumentChangedEdit to be able to perform a redo, it needs to remember the new property value or state. However, the JGoObject.update method does not provide such a new value. The value must be taken from this object and copied into the JGoDocumentChangedEdit by calling setNewValue and/or setNewValueInt.

  Just as the previous/old value/state information is stored as one or both of an integer and an Object, the new value/state information may be stored as either or both of an integer or an Object.

  The responsibility for copying rests with the document event listener rather than the code calling JGoObject.update for efficiency when there is no undo/redo manager.

  Overrides:
    `copyNewValueForRedo` in class `JGoObject`
  Parameters:
    `e` - the UndoableEdit that also remembers the kind of change and any appropriate new state that should be copied in

### changeValue

    public void changeValue(JGoDocumentChangedEdit e,
                            boolean undo)

  Description copied from class: `JGoObject`
  This method is called by the JGoDocumentChangedEdit.undo and redo methods to actually perform the property value change for a JGoObject.

  You will want to override this method to handle changing the additional state of your object subclasses.

  Overrides:
    `changeValue` in class `JGoObject`
  Parameters:
    `e` - the UndoableEdit that also remembers the kind of change and any appropriate old and new state for performing an undo or redo
    `undo` - if true, this method should restore the old state/value, otherwise this method should restore the new state/value

### expandRectByPenWidth

    public void expandRectByPenWidth(java.awt.Rectangle rect)

  Modify the given rectangle representing an object's bounding rectangle to account for any additional drawing region caused by the thickness of the pen.

  Overrides:
    `expandRectByPenWidth` in class `JGoObject`
  Parameters:
    `rect` - the rectangle to be enlarged

### getNearestIntersectionPoint

    public boolean getNearestIntersectionPoint(int px,
                                               int py,
                                               int cx,
                                               int cy,
                                               java.awt.Point result)

  Consider the pen width in determining the nearest intersection point.

  Overrides:
    `getNearestIntersectionPoint` in class `JGoObject`
  Parameters:
    `px` - the X coordinate of a point that starts a line
    `py` - the Y coordinate of a point that starts a line
    `cx` - the X coordinate of a point that specifies the other end of the line
    `cy` - the Y coordinate of a point that specifies the other end of the line
    `result` - a Point that is modified (must not be null)
  Returns:
    whether the line from (px,py) to (cx,cy) intersects the bounding rectangle

### SVGWriteObject

    public void SVGWriteObject(DomDoc svgDoc,
                               DomElement jGoElementGroup)

  Description copied from interface: `JGoXMLSaveRestore`
  Write this object out to a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

  This method will be called by com.nwoods.jgo.svg.DefaultDocument.SVGWriteDoc() for every JGoObject contained within a JGoDocument. The following example uses a JGoRectangle to illustrate the format of a generated SVG JGoObject:

  <g>
  <JGoClass class="com.nwoods.jgo.JGoRectangle"\>
  <rect height="75" style="stroke:black;stroke-width:1;fill:rgb(255,0,0);" width="75" x="65" y="71"/>
  <JGoClass class="com.nwoods.jgo.JGoDrawable" drawablebrush="jgoid1" drawablepen="jgoid2" embeddedpenbrush="false"/>
  <JGoClass class="com.nwoods.jgo.JGoObject" obj_flags="1054"/>
  </g>

  Note that the entire JGoObject is enclosed in a group (<g>). Each subclass of the JGoObject is described by a <JGoClass> element, starting with the most specific class and moving to the more general. Each <JGoClass> element has a "class" attribute which defines the class name. Each <JGoClass> element may also have several other attributes which uniquely describe that state of that class. Following the <JGoClass> element, each class may also genereate any other elements that are required, including representations of contained objects and standard SVG elements such as the <rect> element shown in the above example. The generation of SVG elements in the output makes it possible for the output to be read by SVG viewers and other SVG aware applications. The information contained in the <JGoClass> elements allows us to accurately save and restore all the information in a particular JGoObject subclass.

  If this class contains a reference to another object, call DomDoc.registerReferencingNode() to register that reference. This will cause the element representing the referenced object to be identified with a unique id attribute, and cause the element representing the referring object to have a user defined attribute containing a reference to that id. See DomDoc.registerReferencingNode() for more information.

  Typically, an implementation of this method will generate a <JGoClass> element using the DomDoc.createJGoClassElement() method, adding whatever attributes are necessary to describe the class. It will then call its superclass so that the superclass can add its own <JGoClass> element and other information to jGoElementGroup within the DomDoc.

  Refer to com.nwoods.jgo.examples.flower.ActivityNode.SVGWriteObject() and com.nwoods.jgo.examples.SimpleNode.SVGWriteObject() for examples using this method.

  Refer to the file com.nwoods.jgo.svg\xsvg.dtd for a formal description of JGo extensions to the SVG document type.

  Specified by:
    `SVGWriteObject` in interface `JGoXMLSaveRestore`
  Overrides:
    `SVGWriteObject` in class `JGoObject`

### SVGReadObject

    public DomNode SVGReadObject(DomDoc svgDoc,
                                 JGoDocument jGoDoc,
                                 DomElement svgElement,
                                 DomElement jGoChildElement)

  Description copied from interface: `JGoXMLSaveRestore`
  Read this object in from a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

  This method will be called by com.nwoods.jgo.svg.DefaultDocument.SVGReadDoc() for every <JGoClass> element encountered in a DomDoc. First, an object of the type specified by the class attribute will be created and then the SVGReadObject() method will be called on that newly created object. Refer to SVGWriteObject() for a description of the expected format of the SVG document.

  This method may also be called by com.nwoods.jgo.svg.DefaultDocument.SVGReadDoc() when reading any SVG document, including those not generated by JGo and therefore not containing any <JGoClass> elements. In such cases, the DefaultDocument.SVGReadElement() method may be subclassed to examine the SVG element and cause the appropriate JGoObject to be created to represent that element and call SVGReadObject() on that newly created object. By default, standard JGoObjects such as JGoRectangles, JGoStrokes, etc will be created to represent these objects.

  If this class contains a reference to another object, call DomDoc.registerReferencingObject() to register that reference. This will cause the JGoObject.SVGUpdateReference() to be called on the referencing object after all the objects have been created, passing in the object befing referenced. See DomDoc.registerReferencingObject() for more information.

  Typically, an implementation of this method starts by verifying that the element being read is a <JGoClass> element (which will be true if jGoChildElement is not null). This will always be true unless you have subclassed the DefaultDocument.SVGReadElement() method as described above. It will then read the expected attributes of the <JGoClass> element (as written by SVGReadObject()), call SVGReadObject() on its superclass, and finally return the next element by calling svgElement.getNextSibling().

  Refer to com.nwoods.jgo.examples.flower.ActivityNode.SVGReadObject() and com.nwoods.jgo.examples.SimpleNode.SVGReadObject() for examples using this method.

  Specified by:
    `SVGReadObject` in interface `JGoXMLSaveRestore`
  Overrides:
    `SVGReadObject` in class `JGoObject`

### SVGWriteAttributes

    public void SVGWriteAttributes(DomElement svgElement)

  Description copied from class: `JGoObject`
  This method will add attributes to standard SVG elements.

  Call this method from SVGWriteObject() if standard SVG elements are generated by this class or if this class may be subclassed and it should contribute arguments to SVG elements. For example, the JGoDrawable class implements this method to add standard SVG attributes for stroke, fill, and width. The JGoRectangle class calls this method to add all appropriate attributes to the <rect> element it generates. It is not necessary to implement this method if this class does not contribute any attributes to standard SVG elements. It is not necessary to call this method from SVGWriteObject() if this class does not generate any standard SVG elements.

  Typically, an implementation of this method will first call the superclass and then call DomElement.setAttribute() to add attributes for this class.

  Overrides:
    `SVGWriteAttributes` in class `JGoObject`
  Parameters:
    `svgElement` - the DomElement to which to add attributes
  See Also:
    `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `JGoObject.SVGWriteAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGUpdateReference(java.lang.String, java.lang.Object)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### SVGReadAttributes

    public void SVGReadAttributes(DomElement svgElement)

  Description copied from class: `JGoObject`
  This method will read attributes from standard SVG elements.

  Call this method from SVGReadObject() if standard SVG elements are being read by this class or if this class may be subclassed and it should read arguments from SVG elements. For example, the JGoDrawable class implements this method to read standard SVG attributes for stroke, fill, and width. The JGoRectangle class calls this method to read all appropriate attributes from the <rect> element it is reading. It is not necessary to implement this method if this class does not read any attributes from standard SVG elements. It is not necessary to call this method from SVGReadObject() if this class does not read any standard SVG elements.

  Typically, an implementation of this method will first call the superclass and then call DomElement.getAttribute() to read the attributes for this class.

  Overrides:
    `SVGReadAttributes` in class `JGoObject`
  Parameters:
    `svgElement` - the DomElement from which to read attributes
  See Also:
    `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `JGoObject.SVGWriteAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGUpdateReference(java.lang.String, java.lang.Object)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### SVGUpdateReference

    public void SVGUpdateReference(java.lang.String attr,
                                   java.lang.Object referencedObject)

  Description copied from class: `JGoObject`
  This method will be called to fill in object references.

  This is called by com.nwoods.jgo.svg.DefaultDocument.SVGReadDoc() after all the objects have been created and if DomDoc.registerReferencingObject() has been previously called by SVGReadObject().

  Typically, an implementation of this method will first call the superclass and then fill in the appropriate object reference based on the attr argument.

  Refer to com.nwoods.jgo.examples.SimpleNode.SVGWriteObject() for an example using this method.

  Overrides:
    `SVGUpdateReference` in class `JGoObject`
  Parameters:
    `attr` - the attribute name specified by SVGReadDoc() in DomDoc.registerReferencingObject()
    `referencedObject` - the object being referenced
  See Also:
    `JGoObject.SVGWriteObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadObject(com.nwoods.jgo.DomDoc, com.nwoods.jgo.JGoDocument, com.nwoods.jgo.DomElement, com.nwoods.jgo.DomElement)`, `JGoObject.SVGWriteAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGReadAttributes(com.nwoods.jgo.DomElement)`, `JGoObject.SVGUpdateReference(java.lang.String, java.lang.Object)`, `DomDoc`, `DomNode`, `DomElement`, `DomText`

### drawLine

    public static void drawLine(java.awt.Graphics2D g,
                                JGoPen pen,
                                int x1,
                                int y1,
                                int x2,
                                int y2)

  Draw a straight line, using a specified pen.

  This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.

  Parameters:
    `g` - the graphics object to actually draw on
    `pen` - the pen to draw with
    `x1` - the start point X coordinate
    `y1` - the start point Y coordinate
    `x2` - the end point X coordinate
    `y2` - the end point Y coordinate

### drawLine

    public void drawLine(java.awt.Graphics2D g,
                         int x1,
                         int y1,
                         int x2,
                         int y2)

  Draw a straight line, using the current pen (and no brush).

  Parameters:
    `g` - the graphics object to actually draw on
    `x1` - the start point X coordinate
    `y1` - the start point Y coordinate
    `x2` - the end point X coordinate
    `y2` - the end point Y coordinate

### drawEllipse

    public static void drawEllipse(java.awt.Graphics2D g,
                                   JGoPen pen,
                                   JGoBrush brush,
                                   int x,
                                   int y,
                                   int width,
                                   int height)

  Draw an ellipse, using a specified pen and brush.

  This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.

  Parameters:
    `g` - the graphics object to actually draw on
    `pen` - the pen to draw with
    `brush` - the brush to fill with
    `x` - the left side of the bounding box
    `y` - the top side of the bounding box
    `width` - the width of the bounding box
    `height` - the height of the bounding box

### drawEllipse

    public void drawEllipse(java.awt.Graphics2D g,
                            int x,
                            int y,
                            int width,
                            int height)

  Draw an ellipse, using the current pen and brush.

  Parameters:
    `g` - the graphics object to actually draw on
    `x` - the left side of the bounding box
    `y` - the top side of the bounding box
    `width` - the width of the bounding box
    `height` - the height of the bounding box

### drawEllipse

    public void drawEllipse(java.awt.Graphics2D g,
                            java.awt.Rectangle rect)

  Draw an ellipse, using the current pen and brush, given a rectangle.

  Parameters:
    `g` - the graphics object to actually draw on
    `rect` - the bounding rectangle of the ellipse

### drawRect

    public static void drawRect(java.awt.Graphics2D g,
                                JGoPen pen,
                                JGoBrush brush,
                                int x,
                                int y,
                                int width,
                                int height)

  Draw a rectangle, using a specified pen and brush.

  This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.

  Parameters:
    `g` - the graphics object to actually draw on
    `pen` - the pen to draw with
    `brush` - the brush to fill with
    `x` - the left side of the rectangle
    `y` - the top side of the rectangle
    `width` - the width of the rectangle
    `height` - the height of the rectangle

### drawRect

    public void drawRect(java.awt.Graphics2D g,
                         int x,
                         int y,
                         int width,
                         int height)

  Draw a rectangle, using the current pen and brush.

  Parameters:
    `g` - the graphics object to actually draw on
    `x` - the left side of the rectangle
    `y` - the top side of the rectangle
    `width` - the width of the rectangle
    `height` - the height of the rectangle

### drawRect

    public void drawRect(java.awt.Graphics2D g,
                         java.awt.Rectangle rect)

  Draw a rectangle using the current pen and brush, given a Rectangle.

  Parameters:
    `g` - the graphics object to actually draw on
    `rect` - the bounding rectangle

### drawRoundRect

    public static void drawRoundRect(java.awt.Graphics2D g,
                                     JGoPen pen,
                                     JGoBrush brush,
                                     int x,
                                     int y,
                                     int width,
                                     int height,
                                     int arcWidth,
                                     int arcHeight)

  Draw a rectangle with rounded corners, using a specified pen and brush.

  This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.

  Parameters:
    `g` - the graphics object to actually draw on
    `pen` - the pen to draw with
    `brush` - the brush to fill with
    `x` - the left side of the rectangle
    `y` - the top side of the rectangle
    `width` - the width of the rectangle
    `height` - the height of the rectangle
    `arcWidth` - the width of the rounded corner arc
    `arcHeight` - the height of the rounded corner arc

### drawRoundRect

    public void drawRoundRect(java.awt.Graphics2D g,
                              int x,
                              int y,
                              int width,
                              int height,
                              int arcWidth,
                              int arcHeight)

  Draw a rectangle with rounded corners, using the current pen and brush.

  Parameters:
    `g` - the graphics object to actually draw on
    `x` - the left side of the bounding box
    `y` - the top side of the bounding box
    `width` - the width of the bounding box
    `height` - the height of the bounding box
    `arcWidth` - the width of the arc
    `arcHeight` - the height of the arc

### draw3DRect

    public static void draw3DRect(java.awt.Graphics2D g,
                                  JGoPen pen,
                                  JGoBrush brush,
                                  int x,
                                  int y,
                                  int width,
                                  int height,
                                  boolean raised)

  Draw a rectangle with a 3D appearance, using a specified pen and brush.

  This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.

  Parameters:
    `g` - the graphics object to actually draw on
    `pen` - the pen to draw with
    `brush` - the brush to fill with
    `x` - the left side of the rectangle
    `y` - the top side of the rectangle
    `width` - the width of the rectangle
    `height` - the height of the rectangle
    `raised` - the 3D state of the rectangle

### draw3DRect

    public void draw3DRect(java.awt.Graphics2D g,
                           int x,
                           int y,
                           int width,
                           int height,
                           boolean raised)

  Draw a 3D rectangle using the current pen and brush.

  Parameters:
    `g` - the graphics object to actually draw on
    `x` - the left side of the bounding box
    `y` - the top side of the bounding box
    `width` - the width of the bounding box
    `height` - the height of the bounding box
    `raised` - the 3D state of the rectangle.

### drawPolygon

    public static void drawPolygon(java.awt.Graphics2D g,
                                   JGoPen pen,
                                   JGoBrush brush,
                                   int[] xpoints,
                                   int[] ypoints,
                                   int npoints)

  Draw a polygon using a specified pen and brush.

  This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.

  Parameters:
    `g` - the graphics object to actually draw on
    `pen` - the pen to draw with
    `brush` - the brush to fill with
    `xpoints` - the x-coordinates of all the points
    `ypoints` - the y-coordinates of all the points
    `npoints` - the number of points

### drawPolygon

    public void drawPolygon(java.awt.Graphics2D g,
                            int[] xpoints,
                            int[] ypoints,
                            int npoints)

  Draw a polygon using the current pen and brush.

  Parameters:
    `g` - the graphics object to actually draw on
    `xpoints` - the x-coordinates of all the points
    `ypoints` - the y-coordinates of all the points
    `npoints` - the number of points

### drawPath

    public static void drawPath(java.awt.Graphics2D g,
                                JGoPen pen,
                                JGoBrush brush,
                                java.awt.geom.GeneralPath path)

  Draw a GeneralPath using a specified pen and brush.

  This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.

  Parameters:
    `g` - the graphics object to actually draw on
    `pen` - the pen to draw with
    `brush` - the brush to fill with
    `path` - a GeneralPath

### SVGAddPathArgs

    public static void SVGAddPathArgs(DomElement svgElement,
                                      java.awt.geom.GeneralPath path)

  Add SVG attributes to the element specified by svgElement to draw the path specified by the "path" GeneralPath This is a static method, so that JGoView and JGoObjects other than JGoDrawable are able to use it.

  Parameters:
    `svgElement` - the element to add arguments to
    `path` - the GeneralPath describing the path to draw

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD